/// <reference types="node" />
export declare const OBJECT_ID_KEY = "_objectId";
export declare const TAG_ID_KEY = "_tag";
export declare const BYTES_KEY = "_bytes";
export declare const ELEMENTS_KEY = "_elements";
export declare const BITS_PADDING = "_padding";
export declare const ObjectId: (objectId: string) => {
    _tag: number;
    _bytes: Buffer;
};
export declare const DerObject: (objectId: string, content?: any) => any;
export declare const BitBuffer: (data: Buffer, padding?: number) => {
    _tag: number;
    _bytes: Buffer;
    _padding: number;
};
export declare const ContextTagged: (tagId: number, value?: any) => {
    _tag: number;
    _bytes: Buffer;
};
export declare const ContextTaggedBytes: (tagId: number, value: Buffer) => {
    _tag: number;
    _bytes: Buffer;
};
export declare type DerNode = {
    [TAG_ID_KEY]: number;
    [BYTES_KEY]: Buffer;
    [ELEMENTS_KEY]?: DerNode[];
    [BITS_PADDING]?: number;
};
export declare class DerCodec {
    static encode(value: any): Buffer;
    private static encodeDate;
    private static encodeBoolean;
    private static encodeArray;
    private static encodeOctetString;
    private static encodeObject;
    private static encodeString;
    private static encodeUnsignedInt;
    private static encodeLengthBytes;
    private static encodeAnsi1;
    static decode(data: Buffer): DerNode;
    private static decodeRec;
    private static decodeAnsi1;
}
export declare const PublicKeyEcPrime256v1_X962: (key: Buffer) => {
    type: {
        algorithm: {
            _tag: number;
            _bytes: Buffer;
        };
        curve: {
            _tag: number;
            _bytes: Buffer;
        };
    };
    bytes: {
        _tag: number;
        _bytes: Buffer;
        _padding: number;
    };
};
export declare const EcdsaWithSHA256_X962: any;
export declare const OrganisationName_X520: (name: string) => any[];
export declare const SubjectKeyIdentifier_X509: (identifier: Buffer) => any;
export declare const AuthorityKeyIdentifier_X509: (identifier: Buffer) => any;
export declare const BasicConstraints_X509: (constraints: any) => any;
export declare const ExtendedKeyUsage_X509: ({ clientAuth, serverAuth }: {
    clientAuth: boolean;
    serverAuth: boolean;
}) => any;
export declare const KeyUsage_Signature_X509: any;
export declare const KeyUsage_Signature_ContentCommited_X509: any;
