/// <reference types="node" />
import BN from "bn.js";
export interface PbkdfParameters {
    iteration: number;
    salt: Buffer;
}
export declare class Spake2p {
    private readonly context;
    private readonly random;
    readonly w0: BN;
    private readonly w1;
    constructor(context: Buffer, random: BN, w0: BN, w1: BN);
    static create(context: Buffer, { iteration, salt }: PbkdfParameters, pin: number): Promise<Spake2p>;
    computeX(): Buffer;
    computeY(): Buffer;
    computeSecretAndVerifiersFromY(X: Buffer, Y: Buffer): Promise<{
        Ke: Buffer;
        hAY: Buffer;
        hBX: Buffer;
    }>;
    computeSecretAndVerifiersFromX(X: Buffer, Y: Buffer): Promise<{
        Ke: Buffer;
        hAY: Buffer;
        hBX: Buffer;
    }>;
    private computeSecretAndVerifiers;
    private computeTranscriptHash;
    private addToContext;
}
