/// <reference types="node" />
import { JsType } from "../../codec/TlvObjectCodec";
import { KeyPair } from "../../crypto/Crypto";
export declare function matterToJsDate(date: number): Date;
export declare function jsToMatterDate(date: Date, addYears?: number): number;
export declare const FabricId_Matter: (id: bigint) => any[];
export declare const NodeId_Matter: (id: bigint) => any[];
export declare const RcacId_Matter: (id: number) => any[];
export declare const RootCertificateT: import("../../codec/TlvObjectCodec").Template<import("../../util/Type").Merge<{
    subject: import("../../util/Type").Merge<{
        rcacId: number;
    }, {}, {
        rcacId: number;
    } & {}>;
    serialNumber: Buffer;
    signatureAlgorithm: number;
    issuer: import("../../util/Type").Merge<{}, {
        issuerRcacId?: number | undefined;
    }, {} & {
        issuerRcacId?: number | undefined;
    }>;
    notBefore: number;
    notAfter: number;
    publicKeyAlgorithm: number;
    ellipticCurveIdentifier: number;
    ellipticCurvePublicKey: Buffer;
    extensions: import("../../util/Type").Merge<{
        basicConstraints: import("../../util/Type").Merge<{
            isCa: boolean;
        }, {
            pathLen?: number | undefined;
        }, {
            isCa: boolean;
        } & {
            pathLen?: number | undefined;
        }>;
        keyUsage: number;
        subjectKeyIdentifier: Buffer;
        authorityKeyIdentifier: Buffer;
    }, {
        extendedKeyUsage?: number[] | undefined;
        futureExtension?: Buffer | undefined;
    }, {
        basicConstraints: import("../../util/Type").Merge<{
            isCa: boolean;
        }, {
            pathLen?: number | undefined;
        }, {
            isCa: boolean;
        } & {
            pathLen?: number | undefined;
        }>;
        keyUsage: number;
        subjectKeyIdentifier: Buffer;
        authorityKeyIdentifier: Buffer;
    } & {
        extendedKeyUsage?: number[] | undefined;
        futureExtension?: Buffer | undefined;
    }>;
    signature: Buffer;
}, {}, {
    subject: import("../../util/Type").Merge<{
        rcacId: number;
    }, {}, {
        rcacId: number;
    } & {}>;
    serialNumber: Buffer;
    signatureAlgorithm: number;
    issuer: import("../../util/Type").Merge<{}, {
        issuerRcacId?: number | undefined;
    }, {} & {
        issuerRcacId?: number | undefined;
    }>;
    notBefore: number;
    notAfter: number;
    publicKeyAlgorithm: number;
    ellipticCurveIdentifier: number;
    ellipticCurvePublicKey: Buffer;
    extensions: import("../../util/Type").Merge<{
        basicConstraints: import("../../util/Type").Merge<{
            isCa: boolean;
        }, {
            pathLen?: number | undefined;
        }, {
            isCa: boolean;
        } & {
            pathLen?: number | undefined;
        }>;
        keyUsage: number;
        subjectKeyIdentifier: Buffer;
        authorityKeyIdentifier: Buffer;
    }, {
        extendedKeyUsage?: number[] | undefined;
        futureExtension?: Buffer | undefined;
    }, {
        basicConstraints: import("../../util/Type").Merge<{
            isCa: boolean;
        }, {
            pathLen?: number | undefined;
        }, {
            isCa: boolean;
        } & {
            pathLen?: number | undefined;
        }>;
        keyUsage: number;
        subjectKeyIdentifier: Buffer;
        authorityKeyIdentifier: Buffer;
    } & {
        extendedKeyUsage?: number[] | undefined;
        futureExtension?: Buffer | undefined;
    }>;
    signature: Buffer;
} & {}>>;
export declare const OperationalCertificateT: import("../../codec/TlvObjectCodec").Template<import("../../util/Type").Merge<{
    subject: import("../../util/Type").Merge<{
        fabricId: bigint;
        nodeId: bigint;
    }, {}, {
        fabricId: bigint;
        nodeId: bigint;
    } & {}>;
    serialNumber: Buffer;
    signatureAlgorithm: number;
    issuer: import("../../util/Type").Merge<{}, {
        issuerRcacId?: number | undefined;
    }, {} & {
        issuerRcacId?: number | undefined;
    }>;
    notBefore: number;
    notAfter: number;
    publicKeyAlgorithm: number;
    ellipticCurveIdentifier: number;
    ellipticCurvePublicKey: Buffer;
    extensions: import("../../util/Type").Merge<{
        basicConstraints: import("../../util/Type").Merge<{
            isCa: boolean;
        }, {
            pathLen?: number | undefined;
        }, {
            isCa: boolean;
        } & {
            pathLen?: number | undefined;
        }>;
        keyUsage: number;
        subjectKeyIdentifier: Buffer;
        authorityKeyIdentifier: Buffer;
    }, {
        extendedKeyUsage?: number[] | undefined;
        futureExtension?: Buffer | undefined;
    }, {
        basicConstraints: import("../../util/Type").Merge<{
            isCa: boolean;
        }, {
            pathLen?: number | undefined;
        }, {
            isCa: boolean;
        } & {
            pathLen?: number | undefined;
        }>;
        keyUsage: number;
        subjectKeyIdentifier: Buffer;
        authorityKeyIdentifier: Buffer;
    } & {
        extendedKeyUsage?: number[] | undefined;
        futureExtension?: Buffer | undefined;
    }>;
    signature: Buffer;
}, {}, {
    subject: import("../../util/Type").Merge<{
        fabricId: bigint;
        nodeId: bigint;
    }, {}, {
        fabricId: bigint;
        nodeId: bigint;
    } & {}>;
    serialNumber: Buffer;
    signatureAlgorithm: number;
    issuer: import("../../util/Type").Merge<{}, {
        issuerRcacId?: number | undefined;
    }, {} & {
        issuerRcacId?: number | undefined;
    }>;
    notBefore: number;
    notAfter: number;
    publicKeyAlgorithm: number;
    ellipticCurveIdentifier: number;
    ellipticCurvePublicKey: Buffer;
    extensions: import("../../util/Type").Merge<{
        basicConstraints: import("../../util/Type").Merge<{
            isCa: boolean;
        }, {
            pathLen?: number | undefined;
        }, {
            isCa: boolean;
        } & {
            pathLen?: number | undefined;
        }>;
        keyUsage: number;
        subjectKeyIdentifier: Buffer;
        authorityKeyIdentifier: Buffer;
    }, {
        extendedKeyUsage?: number[] | undefined;
        futureExtension?: Buffer | undefined;
    }, {
        basicConstraints: import("../../util/Type").Merge<{
            isCa: boolean;
        }, {
            pathLen?: number | undefined;
        }, {
            isCa: boolean;
        } & {
            pathLen?: number | undefined;
        }>;
        keyUsage: number;
        subjectKeyIdentifier: Buffer;
        authorityKeyIdentifier: Buffer;
    } & {
        extendedKeyUsage?: number[] | undefined;
        futureExtension?: Buffer | undefined;
    }>;
    signature: Buffer;
} & {}>>;
export declare type RootCertificate = JsType<typeof RootCertificateT>;
export declare type OperationalCertificate = JsType<typeof OperationalCertificateT>;
declare type Unsigned<Type> = {
    [Property in keyof Type as Exclude<Property, "signature">]: Type[Property];
};
export declare class CertificateManager {
    static rootCertToAsn1({ serialNumber, notBefore, notAfter, issuer: { issuerRcacId }, subject: { rcacId }, ellipticCurvePublicKey, extensions: { subjectKeyIdentifier, authorityKeyIdentifier } }: Unsigned<RootCertificate>): Buffer;
    static nocCertToAsn1({ serialNumber, notBefore, notAfter, issuer: { issuerRcacId }, subject: { fabricId, nodeId }, ellipticCurvePublicKey, extensions: { subjectKeyIdentifier, authorityKeyIdentifier } }: Unsigned<OperationalCertificate>): Buffer;
    static validateRootCertificate(rootCert: RootCertificate): void;
    static validateNocCertificate(rootCert: RootCertificate, nocCert: OperationalCertificate): void;
    static createCertificateSigningRequest(keys: KeyPair): Buffer;
    static getPublicKeyFromCsr(csr: Buffer): Buffer;
}
export {};
