"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.CertificateManager = exports.OperationalCertificateT = exports.RootCertificateT = exports.RcacId_Matter = exports.NodeId_Matter = exports.FabricId_Matter = exports.jsToMatterDate = exports.matterToJsDate = void 0;
const DerCodec_1 = require("../../codec/DerCodec");
const TlvCodec_1 = require("../../codec/TlvCodec");
const TlvObjectCodec_1 = require("../../codec/TlvObjectCodec");
const Crypto_1 = require("../../crypto/Crypto");
const YEAR_S = 365 * 24 * 60 * 60;
const EPOCH_OFFSET_S = 10957 * 24 * 60 * 60;
function matterToJsDate(date) {
    return new Date((date + EPOCH_OFFSET_S) * 1000);
}
exports.matterToJsDate = matterToJsDate;
function jsToMatterDate(date, addYears = 0) {
    return Math.floor(date.getTime() / 1000) - EPOCH_OFFSET_S + addYears * YEAR_S;
}
exports.jsToMatterDate = jsToMatterDate;
function intTo16Chars(value) {
    const buffer = Buffer.alloc(8);
    buffer.writeBigUInt64BE(typeof value === "bigint" ? value : BigInt(value));
    return buffer.toString("hex").toUpperCase();
}
const FabricId_Matter = (id) => [(0, DerCodec_1.DerObject)("2b0601040182a27c0105", { value: intTo16Chars(id) })];
exports.FabricId_Matter = FabricId_Matter;
const NodeId_Matter = (id) => [(0, DerCodec_1.DerObject)("2b0601040182a27c0101", { value: intTo16Chars(id) })];
exports.NodeId_Matter = NodeId_Matter;
const RcacId_Matter = (id) => [(0, DerCodec_1.DerObject)("2b0601040182a27c0104", { value: intTo16Chars(id) })];
exports.RcacId_Matter = RcacId_Matter;
exports.RootCertificateT = (0, TlvObjectCodec_1.ObjectT)({
    serialNumber: (0, TlvObjectCodec_1.Field)(1, TlvObjectCodec_1.ByteStringT),
    signatureAlgorithm: (0, TlvObjectCodec_1.Field)(2, TlvObjectCodec_1.UnsignedIntT),
    issuer: (0, TlvObjectCodec_1.Field)(3, (0, TlvObjectCodec_1.ObjectT)({
        issuerRcacId: (0, TlvObjectCodec_1.OptionalField)(20, TlvObjectCodec_1.UnsignedIntT),
    }, TlvCodec_1.TlvType.List)),
    notBefore: (0, TlvObjectCodec_1.Field)(4, TlvObjectCodec_1.UnsignedIntT),
    notAfter: (0, TlvObjectCodec_1.Field)(5, TlvObjectCodec_1.UnsignedIntT),
    subject: (0, TlvObjectCodec_1.Field)(6, (0, TlvObjectCodec_1.ObjectT)({
        rcacId: (0, TlvObjectCodec_1.Field)(20, TlvObjectCodec_1.UnsignedIntT),
    }, TlvCodec_1.TlvType.List)),
    publicKeyAlgorithm: (0, TlvObjectCodec_1.Field)(7, TlvObjectCodec_1.UnsignedIntT),
    ellipticCurveIdentifier: (0, TlvObjectCodec_1.Field)(8, TlvObjectCodec_1.UnsignedIntT),
    ellipticCurvePublicKey: (0, TlvObjectCodec_1.Field)(9, TlvObjectCodec_1.ByteStringT),
    extensions: (0, TlvObjectCodec_1.Field)(10, (0, TlvObjectCodec_1.ObjectT)({
        basicConstraints: (0, TlvObjectCodec_1.Field)(1, (0, TlvObjectCodec_1.ObjectT)({
            isCa: (0, TlvObjectCodec_1.Field)(1, TlvObjectCodec_1.BooleanT),
            pathLen: (0, TlvObjectCodec_1.OptionalField)(2, TlvObjectCodec_1.UnsignedIntT),
        })),
        keyUsage: (0, TlvObjectCodec_1.Field)(2, TlvObjectCodec_1.UnsignedIntT),
        extendedKeyUsage: (0, TlvObjectCodec_1.OptionalField)(3, (0, TlvObjectCodec_1.ArrayT)(TlvObjectCodec_1.UnsignedIntT)),
        subjectKeyIdentifier: (0, TlvObjectCodec_1.Field)(4, TlvObjectCodec_1.ByteStringT),
        authorityKeyIdentifier: (0, TlvObjectCodec_1.Field)(5, TlvObjectCodec_1.ByteStringT),
        futureExtension: (0, TlvObjectCodec_1.OptionalField)(6, TlvObjectCodec_1.ByteStringT),
    }, TlvCodec_1.TlvType.List)),
    signature: (0, TlvObjectCodec_1.Field)(11, TlvObjectCodec_1.ByteStringT),
});
exports.OperationalCertificateT = (0, TlvObjectCodec_1.ObjectT)({
    serialNumber: (0, TlvObjectCodec_1.Field)(1, TlvObjectCodec_1.ByteStringT),
    signatureAlgorithm: (0, TlvObjectCodec_1.Field)(2, TlvObjectCodec_1.UnsignedIntT),
    issuer: (0, TlvObjectCodec_1.Field)(3, (0, TlvObjectCodec_1.ObjectT)({
        issuerRcacId: (0, TlvObjectCodec_1.OptionalField)(20, TlvObjectCodec_1.UnsignedIntT),
    }, TlvCodec_1.TlvType.List)),
    notBefore: (0, TlvObjectCodec_1.Field)(4, TlvObjectCodec_1.UnsignedIntT),
    notAfter: (0, TlvObjectCodec_1.Field)(5, TlvObjectCodec_1.UnsignedIntT),
    subject: (0, TlvObjectCodec_1.Field)(6, (0, TlvObjectCodec_1.ObjectT)({
        fabricId: (0, TlvObjectCodec_1.Field)(21, TlvObjectCodec_1.UnsignedLongT),
        nodeId: (0, TlvObjectCodec_1.Field)(17, TlvObjectCodec_1.UnsignedLongT),
    }, TlvCodec_1.TlvType.List)),
    publicKeyAlgorithm: (0, TlvObjectCodec_1.Field)(7, TlvObjectCodec_1.UnsignedIntT),
    ellipticCurveIdentifier: (0, TlvObjectCodec_1.Field)(8, TlvObjectCodec_1.UnsignedIntT),
    ellipticCurvePublicKey: (0, TlvObjectCodec_1.Field)(9, TlvObjectCodec_1.ByteStringT),
    extensions: (0, TlvObjectCodec_1.Field)(10, (0, TlvObjectCodec_1.ObjectT)({
        basicConstraints: (0, TlvObjectCodec_1.Field)(1, (0, TlvObjectCodec_1.ObjectT)({
            isCa: (0, TlvObjectCodec_1.Field)(1, TlvObjectCodec_1.BooleanT),
            pathLen: (0, TlvObjectCodec_1.OptionalField)(2, TlvObjectCodec_1.UnsignedIntT),
        })),
        keyUsage: (0, TlvObjectCodec_1.Field)(2, TlvObjectCodec_1.UnsignedIntT),
        extendedKeyUsage: (0, TlvObjectCodec_1.OptionalField)(3, (0, TlvObjectCodec_1.ArrayT)(TlvObjectCodec_1.UnsignedIntT)),
        subjectKeyIdentifier: (0, TlvObjectCodec_1.Field)(4, TlvObjectCodec_1.ByteStringT),
        authorityKeyIdentifier: (0, TlvObjectCodec_1.Field)(5, TlvObjectCodec_1.ByteStringT),
        futureExtension: (0, TlvObjectCodec_1.OptionalField)(6, TlvObjectCodec_1.ByteStringT),
    }, TlvCodec_1.TlvType.List)),
    signature: (0, TlvObjectCodec_1.Field)(11, TlvObjectCodec_1.ByteStringT),
});
class CertificateManager {
    static rootCertToAsn1({ serialNumber, notBefore, notAfter, issuer: { issuerRcacId }, subject: { rcacId }, ellipticCurvePublicKey, extensions: { subjectKeyIdentifier, authorityKeyIdentifier } }) {
        return DerCodec_1.DerCodec.encode({
            version: (0, DerCodec_1.ContextTagged)(0, 2),
            serialNumber: serialNumber.readUInt8(),
            signatureAlgorithm: DerCodec_1.EcdsaWithSHA256_X962,
            issuer: {
                issuerRcacId: issuerRcacId === undefined ? undefined : (0, exports.RcacId_Matter)(issuerRcacId),
            },
            validity: {
                notBefore: matterToJsDate(notBefore),
                notAfter: matterToJsDate(notAfter),
            },
            subject: {
                rcacId: (0, exports.RcacId_Matter)(rcacId),
            },
            publicKey: (0, DerCodec_1.PublicKeyEcPrime256v1_X962)(ellipticCurvePublicKey),
            extensions: (0, DerCodec_1.ContextTagged)(3, {
                basicConstraints: (0, DerCodec_1.BasicConstraints_X509)({ isCa: true }),
                keyUsage: DerCodec_1.KeyUsage_Signature_ContentCommited_X509,
                subjectKeyIdentifier: (0, DerCodec_1.SubjectKeyIdentifier_X509)(subjectKeyIdentifier),
                authorityKeyIdentifier: (0, DerCodec_1.AuthorityKeyIdentifier_X509)(authorityKeyIdentifier),
            }),
        });
    }
    static nocCertToAsn1({ serialNumber, notBefore, notAfter, issuer: { issuerRcacId }, subject: { fabricId, nodeId }, ellipticCurvePublicKey, extensions: { subjectKeyIdentifier, authorityKeyIdentifier } }) {
        return DerCodec_1.DerCodec.encode({
            version: (0, DerCodec_1.ContextTagged)(0, 2),
            serialNumber: serialNumber.readUInt8(),
            signatureAlgorithm: DerCodec_1.EcdsaWithSHA256_X962,
            issuer: {
                issuerRcacId: issuerRcacId === undefined ? undefined : (0, exports.RcacId_Matter)(issuerRcacId),
            },
            validity: {
                notBefore: matterToJsDate(notBefore),
                notAfter: matterToJsDate(notAfter),
            },
            subject: {
                fabricId: (0, exports.FabricId_Matter)(fabricId),
                nodeId: (0, exports.NodeId_Matter)(nodeId),
            },
            publicKey: (0, DerCodec_1.PublicKeyEcPrime256v1_X962)(ellipticCurvePublicKey),
            extensions: (0, DerCodec_1.ContextTagged)(3, {
                basicConstraints: (0, DerCodec_1.BasicConstraints_X509)({}),
                keyUsage: DerCodec_1.KeyUsage_Signature_X509,
                extendedKeyUsage: (0, DerCodec_1.ExtendedKeyUsage_X509)({ serverAuth: true, clientAuth: true }),
                subjectKeyIdentifier: (0, DerCodec_1.SubjectKeyIdentifier_X509)(subjectKeyIdentifier),
                authorityKeyIdentifier: (0, DerCodec_1.AuthorityKeyIdentifier_X509)(authorityKeyIdentifier),
            }),
        });
    }
    static validateRootCertificate(rootCert) {
        Crypto_1.Crypto.verify(rootCert.ellipticCurvePublicKey, this.rootCertToAsn1(rootCert), rootCert.signature);
    }
    static validateNocCertificate(rootCert, nocCert) {
        Crypto_1.Crypto.verify(rootCert.ellipticCurvePublicKey, this.nocCertToAsn1(nocCert), nocCert.signature);
    }
    static createCertificateSigningRequest(keys) {
        const request = {
            version: 0,
            subject: { organization: (0, DerCodec_1.OrganisationName_X520)("CSR") },
            publicKey: (0, DerCodec_1.PublicKeyEcPrime256v1_X962)(keys.publicKey),
            endSignedBytes: (0, DerCodec_1.ContextTagged)(0),
        };
        return DerCodec_1.DerCodec.encode({
            request,
            signAlgorithm: DerCodec_1.EcdsaWithSHA256_X962,
            signature: (0, DerCodec_1.BitBuffer)(Crypto_1.Crypto.sign(keys.privateKey, DerCodec_1.DerCodec.encode(request), "der")),
        });
    }
    static getPublicKeyFromCsr(csr) {
        var _a, _b;
        const { [DerCodec_1.ELEMENTS_KEY]: rootElements } = DerCodec_1.DerCodec.decode(csr);
        if ((rootElements === null || rootElements === void 0 ? void 0 : rootElements.length) !== 3)
            throw new Error("Invalid CSR data");
        const [requestNode, signAlgorithmNode, signatureNode] = rootElements;
        const { [DerCodec_1.ELEMENTS_KEY]: requestElements } = requestNode;
        if ((requestElements === null || requestElements === void 0 ? void 0 : requestElements.length) !== 4)
            throw new Error("Invalid CSR data");
        const [versionNode, subjectNode, publicKeyNode] = requestElements;
        const requestVersion = versionNode[DerCodec_1.BYTES_KEY].readUint8();
        if (requestVersion !== 0)
            throw new Error(`Unsupported request version${requestVersion}`);
        const { [DerCodec_1.ELEMENTS_KEY]: publicKeyElements } = publicKeyNode;
        if ((publicKeyElements === null || publicKeyElements === void 0 ? void 0 : publicKeyElements.length) !== 2)
            throw new Error("Invalid CSR data");
        const [publicKeyTypeNode, publicKeyBytesNode] = publicKeyElements;
        const publicKey = publicKeyBytesNode[DerCodec_1.BYTES_KEY];
        if (!DerCodec_1.EcdsaWithSHA256_X962[DerCodec_1.OBJECT_ID_KEY][DerCodec_1.BYTES_KEY].equals((_b = (_a = signAlgorithmNode[DerCodec_1.ELEMENTS_KEY]) === null || _a === void 0 ? void 0 : _a[0]) === null || _b === void 0 ? void 0 : _b[DerCodec_1.BYTES_KEY]))
            throw new Error("Unsupported signature type");
        Crypto_1.Crypto.verify(publicKey, DerCodec_1.DerCodec.encode(requestNode), signatureNode[DerCodec_1.BYTES_KEY], "der");
        return publicKey;
    }
}
exports.CertificateManager = CertificateManager;
