"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.BasicInformationCluster = void 0;
const TlvObjectCodec_1 = require("../../codec/TlvObjectCodec");
const Cluster_1 = require("./Cluster");
const CapabilityMinimaT = (0, TlvObjectCodec_1.ObjectT)({
    caseSessionsPerFabric: (0, TlvObjectCodec_1.Field)(0, TlvObjectCodec_1.UnsignedIntT),
    subscriptionsPerFabric: (0, TlvObjectCodec_1.Field)(1, TlvObjectCodec_1.UnsignedIntT),
});
exports.BasicInformationCluster = (0, Cluster_1.Cluster)(0x28, "Basic Information", {
    dataModelRevision: (0, Cluster_1.Attribute)(0, TlvObjectCodec_1.UnsignedIntT),
    vendorName: (0, Cluster_1.Attribute)(1, TlvObjectCodec_1.StringT),
    vendorId: (0, Cluster_1.Attribute)(2, TlvObjectCodec_1.UnsignedIntT),
    productName: (0, Cluster_1.Attribute)(3, TlvObjectCodec_1.StringT),
    productId: (0, Cluster_1.Attribute)(4, TlvObjectCodec_1.UnsignedIntT),
    nodeLabel: (0, Cluster_1.WritableAttribute)(5, TlvObjectCodec_1.StringT, ""),
    location: (0, Cluster_1.WritableAttribute)(6, TlvObjectCodec_1.StringT, "XX"),
    hardwareVersion: (0, Cluster_1.Attribute)(7, TlvObjectCodec_1.UnsignedIntT, 0),
    hardwareVersionString: (0, Cluster_1.Attribute)(8, TlvObjectCodec_1.StringT),
    softwareVersion: (0, Cluster_1.Attribute)(9, TlvObjectCodec_1.UnsignedIntT, 0),
    softwareVersionString: (0, Cluster_1.Attribute)(10, TlvObjectCodec_1.StringT),
    manufacturingDate: (0, Cluster_1.OptionalAttribute)(11, TlvObjectCodec_1.StringT),
    partNumber: (0, Cluster_1.OptionalAttribute)(12, TlvObjectCodec_1.StringT),
    productURL: (0, Cluster_1.OptionalAttribute)(13, TlvObjectCodec_1.StringT),
    productLabel: (0, Cluster_1.OptionalAttribute)(14, TlvObjectCodec_1.StringT),
    serialNumber: (0, Cluster_1.OptionalAttribute)(15, TlvObjectCodec_1.StringT),
    localConfigDisabled: (0, Cluster_1.OptionalWritableAttribute)(16, TlvObjectCodec_1.BooleanT, false),
    reachable: (0, Cluster_1.OptionalAttribute)(17, TlvObjectCodec_1.BooleanT, true),
    uniqueId: (0, Cluster_1.OptionalAttribute)(18, TlvObjectCodec_1.StringT),
    capabilityMinima: (0, Cluster_1.Attribute)(19, CapabilityMinimaT, {
        caseSessionsPerFabric: 3,
        subscriptionsPerFabric: 3
    }),
}, {});
