import { JsType, Template } from "../../codec/TlvObjectCodec";
import { Attribute, Cluster, Command, WritableAttribute } from "./Cluster";
export declare const enum RegulatoryLocationType {
    Indoor = 0,
    Outdoor = 1,
    IndoorOutdoor = 2
}
export declare const enum CommissioningError {
    Ok = 0,
    ValueOutsideRange = 1,
    InvalidAuthentication = 2,
    NoFailSafe = 3,
    BusyWithOtherAdmin = 4
}
declare const CommissioningSuccessFailureResponseT: Template<import("../../util/Type").Merge<{
    errorCode: CommissioningError;
    debugText: string;
}, {}, {
    errorCode: CommissioningError;
    debugText: string;
} & {}>>;
export declare type CommissioningSuccessFailureResponse = JsType<typeof CommissioningSuccessFailureResponseT>;
export declare const GeneralCommissioningCluster: Cluster<{
    armFailSafe: Command<import("../../util/Type").Merge<{
        expiryLengthSeconds: number;
        breadcrumbStep: bigint;
    }, {}, {
        expiryLengthSeconds: number;
        breadcrumbStep: bigint;
    } & {}>, import("../../util/Type").Merge<{
        errorCode: CommissioningError;
        debugText: string;
    }, {}, {
        errorCode: CommissioningError;
        debugText: string;
    } & {}>>;
    setRegulatoryConfig: Command<import("../../util/Type").Merge<{
        breadcrumbStep: bigint;
        newRegulatoryConfig: RegulatoryLocationType;
        countryCode: string;
    }, {}, {
        breadcrumbStep: bigint;
        newRegulatoryConfig: RegulatoryLocationType;
        countryCode: string;
    } & {}>, import("../../util/Type").Merge<{
        errorCode: CommissioningError;
        debugText: string;
    }, {}, {
        errorCode: CommissioningError;
        debugText: string;
    } & {}>>;
    commissioningComplete: Command<import("../../util/Type").Merge<{}, {}, {} & {}>, import("../../util/Type").Merge<{
        errorCode: CommissioningError;
        debugText: string;
    }, {}, {
        errorCode: CommissioningError;
        debugText: string;
    } & {}>>;
}, {
    breadcrumb: WritableAttribute<bigint>;
    commissioningInfo: Attribute<import("../../util/Type").Merge<{
        failSafeExpiryLengthSeconds: number;
        maxCumulativeFailsafeSeconds: number;
    }, {}, {
        failSafeExpiryLengthSeconds: number;
        maxCumulativeFailsafeSeconds: number;
    } & {}>>;
    regulatoryConfig: Attribute<RegulatoryLocationType>;
    locationCapability: Attribute<RegulatoryLocationType>;
    supportsConcurrentConnections: Attribute<boolean>;
}>;
export {};
