"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.GeneralCommissioningCluster = void 0;
const TlvObjectCodec_1 = require("../../codec/TlvObjectCodec");
const TlvCodec_1 = require("../../codec/TlvCodec");
const Cluster_1 = require("./Cluster");
const RegulatoryLocationTypeT = { tlvType: TlvCodec_1.TlvType.UnsignedInt };
const CommissioningErrorT = { tlvType: TlvCodec_1.TlvType.UnsignedInt };
const BasicCommissioningInfoT = (0, TlvObjectCodec_1.ObjectT)({
    failSafeExpiryLengthSeconds: (0, TlvObjectCodec_1.Field)(0, TlvObjectCodec_1.UnsignedIntT),
    maxCumulativeFailsafeSeconds: (0, TlvObjectCodec_1.Field)(1, TlvObjectCodec_1.UnsignedIntT),
});
const CommissioningSuccessFailureResponseT = (0, TlvObjectCodec_1.ObjectT)({
    errorCode: (0, TlvObjectCodec_1.Field)(0, CommissioningErrorT),
    debugText: (0, TlvObjectCodec_1.Field)(1, TlvObjectCodec_1.StringT),
});
const ArmFailSafeRequestT = (0, TlvObjectCodec_1.ObjectT)({
    expiryLengthSeconds: (0, TlvObjectCodec_1.Field)(0, TlvObjectCodec_1.UnsignedIntT),
    breadcrumbStep: (0, TlvObjectCodec_1.Field)(1, TlvObjectCodec_1.UnsignedLongT),
});
const SetRegulatoryConfigRequestT = (0, TlvObjectCodec_1.ObjectT)({
    newRegulatoryConfig: (0, TlvObjectCodec_1.Field)(0, RegulatoryLocationTypeT),
    countryCode: (0, TlvObjectCodec_1.Field)(1, TlvObjectCodec_1.StringT),
    breadcrumbStep: (0, TlvObjectCodec_1.Field)(2, TlvObjectCodec_1.UnsignedLongT),
});
exports.GeneralCommissioningCluster = (0, Cluster_1.Cluster)(0x30, "General Commissioning", {
    breadcrumb: (0, Cluster_1.WritableAttribute)(0, TlvObjectCodec_1.UnsignedLongT, BigInt(0)),
    commissioningInfo: (0, Cluster_1.Attribute)(1, BasicCommissioningInfoT),
    regulatoryConfig: (0, Cluster_1.Attribute)(2, RegulatoryLocationTypeT),
    locationCapability: (0, Cluster_1.Attribute)(3, RegulatoryLocationTypeT, 2),
    supportsConcurrentConnections: (0, Cluster_1.Attribute)(4, TlvObjectCodec_1.BooleanT, true),
}, {
    armFailSafe: (0, Cluster_1.Command)(0, ArmFailSafeRequestT, 1, CommissioningSuccessFailureResponseT),
    setRegulatoryConfig: (0, Cluster_1.Command)(2, SetRegulatoryConfigRequestT, 3, CommissioningSuccessFailureResponseT),
    commissioningComplete: (0, Cluster_1.Command)(4, Cluster_1.NoArgumentsT, 5, CommissioningSuccessFailureResponseT),
});
