"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.OperationalCredentialsCluster = exports.RemoveFabricRequestT = exports.UpdateFabricLabelRequestT = exports.CertSigningRequestT = exports.AttestationT = exports.OperationalCertificateStatusResponseT = exports.AddTrustedRootCertificateRequestT = exports.UpdateNocRequestT = exports.AddNocRequestT = exports.CertChainResponseT = exports.CertChainRequestT = exports.CertSigningRequestResponseT = exports.CertSigningRequestRequestT = exports.AttestationResponseT = exports.AttestationRequestT = exports.CertificateTypeT = void 0;
const Cluster_1 = require("./Cluster");
const TlvCodec_1 = require("../../codec/TlvCodec");
const TlvObjectCodec_1 = require("../../codec/TlvObjectCodec");
const FabricDescriptorT = (0, TlvObjectCodec_1.ObjectT)({
    rootPublicKey: (0, TlvObjectCodec_1.Field)(1, TlvObjectCodec_1.ByteStringT),
    vendorId: (0, TlvObjectCodec_1.Field)(2, TlvObjectCodec_1.UnsignedIntT),
    fabricID: (0, TlvObjectCodec_1.Field)(3, TlvObjectCodec_1.UnsignedIntT),
    nodeID: (0, TlvObjectCodec_1.Field)(4, TlvObjectCodec_1.UnsignedIntT),
    label: (0, TlvObjectCodec_1.Field)(5, TlvObjectCodec_1.StringT),
});
const NocT = (0, TlvObjectCodec_1.ObjectT)({
    noc: (0, TlvObjectCodec_1.Field)(1, TlvObjectCodec_1.ByteStringT),
    icac: (0, TlvObjectCodec_1.Field)(2, TlvObjectCodec_1.ByteStringT),
});
exports.CertificateTypeT = { tlvType: TlvCodec_1.TlvType.UnsignedInt };
exports.AttestationRequestT = (0, TlvObjectCodec_1.ObjectT)({
    attestationNonce: (0, TlvObjectCodec_1.Field)(0, TlvObjectCodec_1.ByteStringT),
});
exports.AttestationResponseT = (0, TlvObjectCodec_1.ObjectT)({
    elements: (0, TlvObjectCodec_1.Field)(0, TlvObjectCodec_1.ByteStringT),
    signature: (0, TlvObjectCodec_1.Field)(1, TlvObjectCodec_1.ByteStringT),
});
exports.CertSigningRequestRequestT = (0, TlvObjectCodec_1.ObjectT)({
    certSigningRequestNonce: (0, TlvObjectCodec_1.Field)(0, TlvObjectCodec_1.ByteStringT),
    isForUpdateNOC: (0, TlvObjectCodec_1.OptionalField)(1, TlvObjectCodec_1.BooleanT),
});
exports.CertSigningRequestResponseT = (0, TlvObjectCodec_1.ObjectT)({
    elements: (0, TlvObjectCodec_1.Field)(0, TlvObjectCodec_1.ByteStringT),
    signature: (0, TlvObjectCodec_1.Field)(1, TlvObjectCodec_1.ByteStringT),
});
exports.CertChainRequestT = (0, TlvObjectCodec_1.ObjectT)({
    type: (0, TlvObjectCodec_1.Field)(0, exports.CertificateTypeT),
});
exports.CertChainResponseT = (0, TlvObjectCodec_1.ObjectT)({
    certificate: (0, TlvObjectCodec_1.Field)(0, TlvObjectCodec_1.ByteStringT),
});
exports.AddNocRequestT = (0, TlvObjectCodec_1.ObjectT)({
    operationalCert: (0, TlvObjectCodec_1.Field)(0, TlvObjectCodec_1.ByteStringT),
    intermediateCaCert: (0, TlvObjectCodec_1.OptionalField)(1, TlvObjectCodec_1.ByteStringT),
    identityProtectionKey: (0, TlvObjectCodec_1.Field)(2, TlvObjectCodec_1.ByteStringT),
    caseAdminNode: (0, TlvObjectCodec_1.Field)(3, TlvObjectCodec_1.UnsignedLongT),
    adminVendorId: (0, TlvObjectCodec_1.Field)(4, TlvObjectCodec_1.UnsignedIntT),
});
exports.UpdateNocRequestT = (0, TlvObjectCodec_1.ObjectT)({
    operationalCert: (0, TlvObjectCodec_1.Field)(0, TlvObjectCodec_1.ByteStringT),
    intermediateCaCert: (0, TlvObjectCodec_1.OptionalField)(1, TlvObjectCodec_1.ByteStringT),
});
exports.AddTrustedRootCertificateRequestT = (0, TlvObjectCodec_1.ObjectT)({
    certificate: (0, TlvObjectCodec_1.Field)(0, TlvObjectCodec_1.ByteStringT),
});
const OperationalCertStatusT = { tlvType: TlvCodec_1.TlvType.UnsignedInt };
exports.OperationalCertificateStatusResponseT = (0, TlvObjectCodec_1.ObjectT)({
    status: (0, TlvObjectCodec_1.Field)(0, OperationalCertStatusT),
    fabricIndex: (0, TlvObjectCodec_1.OptionalField)(1, TlvObjectCodec_1.UnsignedIntT),
    debugText: (0, TlvObjectCodec_1.OptionalField)(2, TlvObjectCodec_1.StringT),
});
exports.AttestationT = (0, TlvObjectCodec_1.ObjectT)({
    declaration: (0, TlvObjectCodec_1.Field)(1, TlvObjectCodec_1.ByteStringT),
    attestationNonce: (0, TlvObjectCodec_1.Field)(2, TlvObjectCodec_1.ByteStringT),
    timestamp: (0, TlvObjectCodec_1.Field)(3, TlvObjectCodec_1.UnsignedIntT),
    firmwareInfo: (0, TlvObjectCodec_1.OptionalField)(4, TlvObjectCodec_1.ByteStringT),
});
exports.CertSigningRequestT = (0, TlvObjectCodec_1.ObjectT)({
    certSigningRequest: (0, TlvObjectCodec_1.Field)(1, TlvObjectCodec_1.ByteStringT),
    certSigningRequestNonce: (0, TlvObjectCodec_1.Field)(2, TlvObjectCodec_1.ByteStringT),
    vendorReserved1: (0, TlvObjectCodec_1.OptionalField)(3, TlvObjectCodec_1.ByteStringT),
    vendorReserved2: (0, TlvObjectCodec_1.OptionalField)(4, TlvObjectCodec_1.ByteStringT),
    vendorReserved3: (0, TlvObjectCodec_1.OptionalField)(5, TlvObjectCodec_1.ByteStringT),
});
exports.UpdateFabricLabelRequestT = (0, TlvObjectCodec_1.ObjectT)({
    fabricIndex: (0, TlvObjectCodec_1.Field)(0, TlvObjectCodec_1.UnsignedIntT),
});
exports.RemoveFabricRequestT = (0, TlvObjectCodec_1.ObjectT)({
    fabricIndex: (0, TlvObjectCodec_1.Field)(0, TlvObjectCodec_1.UnsignedIntT),
});
exports.OperationalCredentialsCluster = (0, Cluster_1.Cluster)(0x3e, "Operational Credentials", {
    nocs: (0, Cluster_1.Attribute)(0, (0, TlvObjectCodec_1.ArrayT)(NocT)),
    fabrics: (0, Cluster_1.Attribute)(1, (0, TlvObjectCodec_1.ArrayT)(FabricDescriptorT)),
    supportedFabrics: (0, Cluster_1.Attribute)(2, TlvObjectCodec_1.UnsignedIntT),
    commissionedFabrics: (0, Cluster_1.Attribute)(3, TlvObjectCodec_1.UnsignedIntT),
    trustedRootCertificates: (0, Cluster_1.Attribute)(4, (0, TlvObjectCodec_1.ArrayT)(TlvObjectCodec_1.ByteStringT)),
    currentFabricIndex: (0, Cluster_1.Attribute)(5, TlvObjectCodec_1.UnsignedIntT),
}, {
    requestAttestation: (0, Cluster_1.Command)(0, exports.AttestationRequestT, 1, exports.AttestationResponseT),
    requestCertChain: (0, Cluster_1.Command)(2, exports.CertChainRequestT, 3, exports.CertChainResponseT),
    requestCertSigning: (0, Cluster_1.Command)(4, exports.CertSigningRequestRequestT, 5, exports.CertSigningRequestResponseT),
    addOperationalCert: (0, Cluster_1.Command)(6, exports.AddNocRequestT, 8, exports.OperationalCertificateStatusResponseT),
    updateOperationalCert: (0, Cluster_1.Command)(7, exports.UpdateNocRequestT, 8, exports.OperationalCertificateStatusResponseT),
    updateFabricLabel: (0, Cluster_1.Command)(9, exports.UpdateFabricLabelRequestT, 8, exports.OperationalCertificateStatusResponseT),
    removeFabric: (0, Cluster_1.Command)(10, exports.RemoveFabricRequestT, 8, exports.OperationalCertificateStatusResponseT),
    addRootCert: (0, Cluster_1.Command)(11, exports.AddTrustedRootCertificateRequestT, 11, Cluster_1.NoResponseT),
});
