import { Template } from "../../../codec/TlvObjectCodec";
export declare class AttributeServer<T> {
    readonly id: number;
    readonly name: string;
    readonly template: Template<T>;
    private value;
    private version;
    private readonly matterListeners;
    private readonly listeners;
    constructor(id: number, name: string, template: Template<T>, defaultValue: T);
    set(value: T): void;
    get(): T;
    getWithVersion(): {
        version: number;
        value: T;
    };
    addMatterListener(listener: (value: T, version: number) => void): void;
    removeMatterListener(listener: (value: T, version: number) => void): void;
    addListener(listener: (newValue: T, oldValue: T) => void): void;
    removeListener(listener: (newValue: T, oldValue: T) => void): void;
}
