import { Element } from "../../../codec/TlvCodec";
import { Template } from "../../../codec/TlvObjectCodec";
import { MatterDevice } from "../../MatterDevice";
import { Session } from "../../session/Session";
export declare const enum ResultCode {
    Success = 0
}
export declare class CommandServer<RequestT, ResponseT> {
    readonly invokeId: number;
    readonly responseId: number;
    readonly name: string;
    protected readonly requestTemplate: Template<RequestT>;
    protected readonly responseTemplate: Template<ResponseT>;
    protected readonly handler: (request: RequestT, session: Session<MatterDevice>) => Promise<ResponseT> | ResponseT;
    constructor(invokeId: number, responseId: number, name: string, requestTemplate: Template<RequestT>, responseTemplate: Template<ResponseT>, handler: (request: RequestT, session: Session<MatterDevice>) => Promise<ResponseT> | ResponseT);
    invoke(session: Session<MatterDevice>, args: Element): Promise<{
        code: ResultCode;
        responseId: number;
        response?: Element;
    }>;
}
