"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.CommandServer = void 0;
const TlvObjectCodec_1 = require("../../../codec/TlvObjectCodec");
class CommandServer {
    constructor(invokeId, responseId, name, requestTemplate, responseTemplate, handler) {
        this.invokeId = invokeId;
        this.responseId = responseId;
        this.name = name;
        this.requestTemplate = requestTemplate;
        this.responseTemplate = responseTemplate;
        this.handler = handler;
    }
    invoke(session, args) {
        return __awaiter(this, void 0, void 0, function* () {
            const request = TlvObjectCodec_1.TlvObjectCodec.decodeElement(args, this.requestTemplate);
            const response = yield this.handler(request, session);
            return { code: 0, responseId: this.responseId, response: TlvObjectCodec_1.TlvObjectCodec.encodeElement(response, this.responseTemplate) };
        });
    }
}
exports.CommandServer = CommandServer;
