import { Template } from "../../codec/TlvObjectCodec";
export declare const enum StatusCode {
    Success = 0,
    Failure = 1
}
export declare const StatusCodeT: Template<StatusCode>;
export declare const StatusResponseT: Template<import("../../util/Type").Merge<{
    status: StatusCode;
    interactionModelRevision: number;
}, {}, {
    status: StatusCode;
    interactionModelRevision: number;
} & {}>>;
export declare const ReadRequestT: Template<import("../../util/Type").Merge<{
    attributes: import("../../util/Type").Merge<{}, {
        id?: number | undefined;
        endpointId?: number | undefined;
        clusterId?: number | undefined;
    }, {} & {
        id?: number | undefined;
        endpointId?: number | undefined;
        clusterId?: number | undefined;
    }>[];
    interactionModelRevision: number;
    isFabricFiltered: boolean;
}, {}, {
    attributes: import("../../util/Type").Merge<{}, {
        id?: number | undefined;
        endpointId?: number | undefined;
        clusterId?: number | undefined;
    }, {} & {
        id?: number | undefined;
        endpointId?: number | undefined;
        clusterId?: number | undefined;
    }>[];
    interactionModelRevision: number;
    isFabricFiltered: boolean;
} & {}>>;
export declare const DataReportT: Template<import("../../util/Type").Merge<{
    values: import("../../util/Type").Merge<{
        value: import("../../util/Type").Merge<{
            value: any;
            path: import("../../util/Type").Merge<{
                id: number;
                endpointId: number;
                clusterId: number;
            }, {}, {
                id: number;
                endpointId: number;
                clusterId: number;
            } & {}>;
            version: number;
        }, {}, {
            value: any;
            path: import("../../util/Type").Merge<{
                id: number;
                endpointId: number;
                clusterId: number;
            }, {}, {
                id: number;
                endpointId: number;
                clusterId: number;
            } & {}>;
            version: number;
        } & {}>;
    }, {}, {
        value: import("../../util/Type").Merge<{
            value: any;
            path: import("../../util/Type").Merge<{
                id: number;
                endpointId: number;
                clusterId: number;
            }, {}, {
                id: number;
                endpointId: number;
                clusterId: number;
            } & {}>;
            version: number;
        }, {}, {
            value: any;
            path: import("../../util/Type").Merge<{
                id: number;
                endpointId: number;
                clusterId: number;
            }, {}, {
                id: number;
                endpointId: number;
                clusterId: number;
            } & {}>;
            version: number;
        } & {}>;
    } & {}>[];
    interactionModelRevision: number;
}, {
    isFabricFiltered?: boolean | undefined;
    subscriptionId?: number | undefined;
}, {
    values: import("../../util/Type").Merge<{
        value: import("../../util/Type").Merge<{
            value: any;
            path: import("../../util/Type").Merge<{
                id: number;
                endpointId: number;
                clusterId: number;
            }, {}, {
                id: number;
                endpointId: number;
                clusterId: number;
            } & {}>;
            version: number;
        }, {}, {
            value: any;
            path: import("../../util/Type").Merge<{
                id: number;
                endpointId: number;
                clusterId: number;
            }, {}, {
                id: number;
                endpointId: number;
                clusterId: number;
            } & {}>;
            version: number;
        } & {}>;
    }, {}, {
        value: import("../../util/Type").Merge<{
            value: any;
            path: import("../../util/Type").Merge<{
                id: number;
                endpointId: number;
                clusterId: number;
            }, {}, {
                id: number;
                endpointId: number;
                clusterId: number;
            } & {}>;
            version: number;
        }, {}, {
            value: any;
            path: import("../../util/Type").Merge<{
                id: number;
                endpointId: number;
                clusterId: number;
            }, {}, {
                id: number;
                endpointId: number;
                clusterId: number;
            } & {}>;
            version: number;
        } & {}>;
    } & {}>[];
    interactionModelRevision: number;
} & {
    isFabricFiltered?: boolean | undefined;
    subscriptionId?: number | undefined;
}>>;
export declare const SubscribeRequestT: Template<import("../../util/Type").Merge<{
    isFabricFiltered: boolean;
    keepSubscriptions: boolean;
    minIntervalFloorSeconds: number;
    maxIntervalCeilingSeconds: number;
}, {
    attributeRequests?: import("../../util/Type").Merge<{}, {
        id?: number | undefined;
        endpointId?: number | undefined;
        clusterId?: number | undefined;
    }, {} & {
        id?: number | undefined;
        endpointId?: number | undefined;
        clusterId?: number | undefined;
    }>[] | undefined;
    eventRequests?: import("../../util/Type").Merge<{
        event: number;
        node: number;
        endpoint: number;
        cluster: number;
        isUrgent: boolean;
    }, {}, {
        event: number;
        node: number;
        endpoint: number;
        cluster: number;
        isUrgent: boolean;
    } & {}>[] | undefined;
    eventFilters?: import("../../util/Type").Merge<{
        node: number;
        eventMin: bigint;
    }, {}, {
        node: number;
        eventMin: bigint;
    } & {}>[] | undefined;
    dataVersionFilters?: import("../../util/Type").Merge<{
        path: import("../../util/Type").Merge<{
            node: number;
            endpoint: number;
            cluster: number;
        }, {}, {
            node: number;
            endpoint: number;
            cluster: number;
        } & {}>;
        dataVersion: number;
    }, {}, {
        path: import("../../util/Type").Merge<{
            node: number;
            endpoint: number;
            cluster: number;
        }, {}, {
            node: number;
            endpoint: number;
            cluster: number;
        } & {}>;
        dataVersion: number;
    } & {}>[] | undefined;
}, {
    isFabricFiltered: boolean;
    keepSubscriptions: boolean;
    minIntervalFloorSeconds: number;
    maxIntervalCeilingSeconds: number;
} & {
    attributeRequests?: import("../../util/Type").Merge<{}, {
        id?: number | undefined;
        endpointId?: number | undefined;
        clusterId?: number | undefined;
    }, {} & {
        id?: number | undefined;
        endpointId?: number | undefined;
        clusterId?: number | undefined;
    }>[] | undefined;
    eventRequests?: import("../../util/Type").Merge<{
        event: number;
        node: number;
        endpoint: number;
        cluster: number;
        isUrgent: boolean;
    }, {}, {
        event: number;
        node: number;
        endpoint: number;
        cluster: number;
        isUrgent: boolean;
    } & {}>[] | undefined;
    eventFilters?: import("../../util/Type").Merge<{
        node: number;
        eventMin: bigint;
    }, {}, {
        node: number;
        eventMin: bigint;
    } & {}>[] | undefined;
    dataVersionFilters?: import("../../util/Type").Merge<{
        path: import("../../util/Type").Merge<{
            node: number;
            endpoint: number;
            cluster: number;
        }, {}, {
            node: number;
            endpoint: number;
            cluster: number;
        } & {}>;
        dataVersion: number;
    }, {}, {
        path: import("../../util/Type").Merge<{
            node: number;
            endpoint: number;
            cluster: number;
        }, {}, {
            node: number;
            endpoint: number;
            cluster: number;
        } & {}>;
        dataVersion: number;
    } & {}>[] | undefined;
}>>;
export declare const SubscribeResponseT: Template<import("../../util/Type").Merge<{
    interactionModelRevision: number;
    subscriptionId: number;
    maxIntervalCeilingSeconds: number;
}, {}, {
    interactionModelRevision: number;
    subscriptionId: number;
    maxIntervalCeilingSeconds: number;
} & {}>>;
export declare const InvokeRequestT: Template<import("../../util/Type").Merge<{
    suppressResponse: boolean;
    timedRequest: boolean;
    invokes: import("../../util/Type").Merge<{
        path: import("../../util/Type").Merge<{
            id: number;
            endpointId: number;
            clusterId: number;
        }, {}, {
            id: number;
            endpointId: number;
            clusterId: number;
        } & {}>;
        args: any;
    }, {}, {
        path: import("../../util/Type").Merge<{
            id: number;
            endpointId: number;
            clusterId: number;
        }, {}, {
            id: number;
            endpointId: number;
            clusterId: number;
        } & {}>;
        args: any;
    } & {}>[];
}, {}, {
    suppressResponse: boolean;
    timedRequest: boolean;
    invokes: import("../../util/Type").Merge<{
        path: import("../../util/Type").Merge<{
            id: number;
            endpointId: number;
            clusterId: number;
        }, {}, {
            id: number;
            endpointId: number;
            clusterId: number;
        } & {}>;
        args: any;
    }, {}, {
        path: import("../../util/Type").Merge<{
            id: number;
            endpointId: number;
            clusterId: number;
        }, {}, {
            id: number;
            endpointId: number;
            clusterId: number;
        } & {}>;
        args: any;
    } & {}>[];
} & {}>>;
export declare const InvokeResponseT: Template<import("../../util/Type").Merge<{
    interactionModelRevision: number;
    suppressResponse: boolean;
    responses: import("../../util/Type").Merge<{}, {
        response?: import("../../util/Type").Merge<{
            path: import("../../util/Type").Merge<{
                id: number;
                endpointId: number;
                clusterId: number;
            }, {}, {
                id: number;
                endpointId: number;
                clusterId: number;
            } & {}>;
            response: any;
        }, {}, {
            path: import("../../util/Type").Merge<{
                id: number;
                endpointId: number;
                clusterId: number;
            }, {}, {
                id: number;
                endpointId: number;
                clusterId: number;
            } & {}>;
            response: any;
        } & {}> | undefined;
        result?: import("../../util/Type").Merge<{
            path: import("../../util/Type").Merge<{
                id: number;
                endpointId: number;
                clusterId: number;
            }, {}, {
                id: number;
                endpointId: number;
                clusterId: number;
            } & {}>;
            result: import("../../util/Type").Merge<{
                code: number;
            }, {}, {
                code: number;
            } & {}>;
        }, {}, {
            path: import("../../util/Type").Merge<{
                id: number;
                endpointId: number;
                clusterId: number;
            }, {}, {
                id: number;
                endpointId: number;
                clusterId: number;
            } & {}>;
            result: import("../../util/Type").Merge<{
                code: number;
            }, {}, {
                code: number;
            } & {}>;
        } & {}> | undefined;
    }, {} & {
        response?: import("../../util/Type").Merge<{
            path: import("../../util/Type").Merge<{
                id: number;
                endpointId: number;
                clusterId: number;
            }, {}, {
                id: number;
                endpointId: number;
                clusterId: number;
            } & {}>;
            response: any;
        }, {}, {
            path: import("../../util/Type").Merge<{
                id: number;
                endpointId: number;
                clusterId: number;
            }, {}, {
                id: number;
                endpointId: number;
                clusterId: number;
            } & {}>;
            response: any;
        } & {}> | undefined;
        result?: import("../../util/Type").Merge<{
            path: import("../../util/Type").Merge<{
                id: number;
                endpointId: number;
                clusterId: number;
            }, {}, {
                id: number;
                endpointId: number;
                clusterId: number;
            } & {}>;
            result: import("../../util/Type").Merge<{
                code: number;
            }, {}, {
                code: number;
            } & {}>;
        }, {}, {
            path: import("../../util/Type").Merge<{
                id: number;
                endpointId: number;
                clusterId: number;
            }, {}, {
                id: number;
                endpointId: number;
                clusterId: number;
            } & {}>;
            result: import("../../util/Type").Merge<{
                code: number;
            }, {}, {
                code: number;
            } & {}>;
        } & {}> | undefined;
    }>[];
}, {}, {
    interactionModelRevision: number;
    suppressResponse: boolean;
    responses: import("../../util/Type").Merge<{}, {
        response?: import("../../util/Type").Merge<{
            path: import("../../util/Type").Merge<{
                id: number;
                endpointId: number;
                clusterId: number;
            }, {}, {
                id: number;
                endpointId: number;
                clusterId: number;
            } & {}>;
            response: any;
        }, {}, {
            path: import("../../util/Type").Merge<{
                id: number;
                endpointId: number;
                clusterId: number;
            }, {}, {
                id: number;
                endpointId: number;
                clusterId: number;
            } & {}>;
            response: any;
        } & {}> | undefined;
        result?: import("../../util/Type").Merge<{
            path: import("../../util/Type").Merge<{
                id: number;
                endpointId: number;
                clusterId: number;
            }, {}, {
                id: number;
                endpointId: number;
                clusterId: number;
            } & {}>;
            result: import("../../util/Type").Merge<{
                code: number;
            }, {}, {
                code: number;
            } & {}>;
        }, {}, {
            path: import("../../util/Type").Merge<{
                id: number;
                endpointId: number;
                clusterId: number;
            }, {}, {
                id: number;
                endpointId: number;
                clusterId: number;
            } & {}>;
            result: import("../../util/Type").Merge<{
                code: number;
            }, {}, {
                code: number;
            } & {}>;
        } & {}> | undefined;
    }, {} & {
        response?: import("../../util/Type").Merge<{
            path: import("../../util/Type").Merge<{
                id: number;
                endpointId: number;
                clusterId: number;
            }, {}, {
                id: number;
                endpointId: number;
                clusterId: number;
            } & {}>;
            response: any;
        }, {}, {
            path: import("../../util/Type").Merge<{
                id: number;
                endpointId: number;
                clusterId: number;
            }, {}, {
                id: number;
                endpointId: number;
                clusterId: number;
            } & {}>;
            response: any;
        } & {}> | undefined;
        result?: import("../../util/Type").Merge<{
            path: import("../../util/Type").Merge<{
                id: number;
                endpointId: number;
                clusterId: number;
            }, {}, {
                id: number;
                endpointId: number;
                clusterId: number;
            } & {}>;
            result: import("../../util/Type").Merge<{
                code: number;
            }, {}, {
                code: number;
            } & {}>;
        }, {}, {
            path: import("../../util/Type").Merge<{
                id: number;
                endpointId: number;
                clusterId: number;
            }, {}, {
                id: number;
                endpointId: number;
                clusterId: number;
            } & {}>;
            result: import("../../util/Type").Merge<{
                code: number;
            }, {}, {
                code: number;
            } & {}>;
        } & {}> | undefined;
    }>[];
} & {}>>;
