"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.InvokeResponseT = exports.InvokeRequestT = exports.SubscribeResponseT = exports.SubscribeRequestT = exports.DataReportT = exports.ReadRequestT = exports.StatusResponseT = exports.StatusCodeT = void 0;
const TlvCodec_1 = require("../../codec/TlvCodec");
const TlvObjectCodec_1 = require("../../codec/TlvObjectCodec");
exports.StatusCodeT = { tlvType: TlvCodec_1.TlvType.UnsignedInt };
exports.StatusResponseT = (0, TlvObjectCodec_1.ObjectT)({
    status: (0, TlvObjectCodec_1.Field)(0, exports.StatusCodeT),
    interactionModelRevision: (0, TlvObjectCodec_1.Field)(0xFF, TlvObjectCodec_1.UnsignedIntT),
});
const AttributePathT = (0, TlvObjectCodec_1.ObjectT)({
    endpointId: (0, TlvObjectCodec_1.OptionalField)(2, TlvObjectCodec_1.UnsignedIntT),
    clusterId: (0, TlvObjectCodec_1.OptionalField)(3, TlvObjectCodec_1.UnsignedIntT),
    id: (0, TlvObjectCodec_1.OptionalField)(4, TlvObjectCodec_1.UnsignedIntT),
}, TlvCodec_1.TlvType.List);
exports.ReadRequestT = (0, TlvObjectCodec_1.ObjectT)({
    attributes: (0, TlvObjectCodec_1.Field)(0, (0, TlvObjectCodec_1.ArrayT)(AttributePathT)),
    isFabricFiltered: (0, TlvObjectCodec_1.Field)(3, TlvObjectCodec_1.BooleanT),
    interactionModelRevision: (0, TlvObjectCodec_1.Field)(0xFF, TlvObjectCodec_1.UnsignedIntT),
});
exports.DataReportT = (0, TlvObjectCodec_1.ObjectT)({
    subscriptionId: (0, TlvObjectCodec_1.OptionalField)(0, TlvObjectCodec_1.UnsignedIntT),
    values: (0, TlvObjectCodec_1.Field)(1, (0, TlvObjectCodec_1.ArrayT)((0, TlvObjectCodec_1.ObjectT)({
        value: (0, TlvObjectCodec_1.Field)(1, (0, TlvObjectCodec_1.ObjectT)({
            version: (0, TlvObjectCodec_1.Field)(0, TlvObjectCodec_1.UnsignedIntT),
            path: (0, TlvObjectCodec_1.Field)(1, (0, TlvObjectCodec_1.ObjectT)({
                endpointId: (0, TlvObjectCodec_1.Field)(2, TlvObjectCodec_1.UnsignedIntT),
                clusterId: (0, TlvObjectCodec_1.Field)(3, TlvObjectCodec_1.UnsignedIntT),
                id: (0, TlvObjectCodec_1.Field)(4, TlvObjectCodec_1.UnsignedIntT),
            }, TlvCodec_1.TlvType.List)),
            value: (0, TlvObjectCodec_1.Field)(2, TlvObjectCodec_1.AnyT),
        })),
    }))),
    isFabricFiltered: (0, TlvObjectCodec_1.OptionalField)(4, TlvObjectCodec_1.BooleanT),
    interactionModelRevision: (0, TlvObjectCodec_1.Field)(0xFF, TlvObjectCodec_1.UnsignedIntT),
});
exports.SubscribeRequestT = (0, TlvObjectCodec_1.ObjectT)({
    keepSubscriptions: (0, TlvObjectCodec_1.Field)(0, TlvObjectCodec_1.BooleanT),
    minIntervalFloorSeconds: (0, TlvObjectCodec_1.Field)(1, TlvObjectCodec_1.UnsignedIntT),
    maxIntervalCeilingSeconds: (0, TlvObjectCodec_1.Field)(2, TlvObjectCodec_1.UnsignedIntT),
    attributeRequests: (0, TlvObjectCodec_1.OptionalField)(3, (0, TlvObjectCodec_1.ArrayT)(AttributePathT)),
    eventRequests: (0, TlvObjectCodec_1.OptionalField)(4, (0, TlvObjectCodec_1.ArrayT)((0, TlvObjectCodec_1.ObjectT)({
        node: (0, TlvObjectCodec_1.Field)(0, TlvObjectCodec_1.UnsignedIntT),
        endpoint: (0, TlvObjectCodec_1.Field)(1, TlvObjectCodec_1.UnsignedIntT),
        cluster: (0, TlvObjectCodec_1.Field)(2, TlvObjectCodec_1.UnsignedIntT),
        event: (0, TlvObjectCodec_1.Field)(3, TlvObjectCodec_1.UnsignedIntT),
        isUrgent: (0, TlvObjectCodec_1.Field)(4, TlvObjectCodec_1.BooleanT),
    }, TlvCodec_1.TlvType.List))),
    eventFilters: (0, TlvObjectCodec_1.OptionalField)(5, (0, TlvObjectCodec_1.ArrayT)((0, TlvObjectCodec_1.ObjectT)({
        node: (0, TlvObjectCodec_1.Field)(0, TlvObjectCodec_1.UnsignedIntT),
        eventMin: (0, TlvObjectCodec_1.Field)(1, TlvObjectCodec_1.UnsignedLongT),
    }, TlvCodec_1.TlvType.List))),
    isFabricFiltered: (0, TlvObjectCodec_1.Field)(7, TlvObjectCodec_1.BooleanT),
    dataVersionFilters: (0, TlvObjectCodec_1.OptionalField)(8, (0, TlvObjectCodec_1.ArrayT)((0, TlvObjectCodec_1.ObjectT)({
        path: (0, TlvObjectCodec_1.Field)(0, (0, TlvObjectCodec_1.ObjectT)({
            node: (0, TlvObjectCodec_1.Field)(0, TlvObjectCodec_1.UnsignedIntT),
            endpoint: (0, TlvObjectCodec_1.Field)(1, TlvObjectCodec_1.UnsignedIntT),
            cluster: (0, TlvObjectCodec_1.Field)(2, TlvObjectCodec_1.UnsignedIntT),
        }, TlvCodec_1.TlvType.List)),
        dataVersion: (0, TlvObjectCodec_1.Field)(1, TlvObjectCodec_1.UnsignedIntT),
    }))),
});
exports.SubscribeResponseT = (0, TlvObjectCodec_1.ObjectT)({
    subscriptionId: (0, TlvObjectCodec_1.Field)(0, TlvObjectCodec_1.UnsignedIntT),
    maxIntervalCeilingSeconds: (0, TlvObjectCodec_1.Field)(2, TlvObjectCodec_1.UnsignedIntT),
    interactionModelRevision: (0, TlvObjectCodec_1.Field)(0xFF, TlvObjectCodec_1.UnsignedIntT),
});
exports.InvokeRequestT = (0, TlvObjectCodec_1.ObjectT)({
    suppressResponse: (0, TlvObjectCodec_1.Field)(0, TlvObjectCodec_1.BooleanT),
    timedRequest: (0, TlvObjectCodec_1.Field)(1, TlvObjectCodec_1.BooleanT),
    invokes: (0, TlvObjectCodec_1.Field)(2, (0, TlvObjectCodec_1.ArrayT)((0, TlvObjectCodec_1.ObjectT)({
        path: (0, TlvObjectCodec_1.Field)(0, (0, TlvObjectCodec_1.ObjectT)({
            endpointId: (0, TlvObjectCodec_1.Field)(0, TlvObjectCodec_1.UnsignedIntT),
            clusterId: (0, TlvObjectCodec_1.Field)(1, TlvObjectCodec_1.UnsignedIntT),
            id: (0, TlvObjectCodec_1.Field)(2, TlvObjectCodec_1.UnsignedIntT),
        }, TlvCodec_1.TlvType.List)),
        args: (0, TlvObjectCodec_1.Field)(1, TlvObjectCodec_1.AnyT),
    }))),
});
exports.InvokeResponseT = (0, TlvObjectCodec_1.ObjectT)({
    suppressResponse: (0, TlvObjectCodec_1.Field)(0, TlvObjectCodec_1.BooleanT),
    responses: (0, TlvObjectCodec_1.Field)(1, (0, TlvObjectCodec_1.ArrayT)((0, TlvObjectCodec_1.ObjectT)({
        response: (0, TlvObjectCodec_1.OptionalField)(0, (0, TlvObjectCodec_1.ObjectT)({
            path: (0, TlvObjectCodec_1.Field)(0, (0, TlvObjectCodec_1.ObjectT)({
                endpointId: (0, TlvObjectCodec_1.Field)(0, TlvObjectCodec_1.UnsignedIntT),
                clusterId: (0, TlvObjectCodec_1.Field)(1, TlvObjectCodec_1.UnsignedIntT),
                id: (0, TlvObjectCodec_1.Field)(2, TlvObjectCodec_1.UnsignedIntT),
            }, TlvCodec_1.TlvType.List)),
            response: (0, TlvObjectCodec_1.Field)(1, TlvObjectCodec_1.AnyT),
        })),
        result: (0, TlvObjectCodec_1.OptionalField)(1, (0, TlvObjectCodec_1.ObjectT)({
            path: (0, TlvObjectCodec_1.Field)(0, (0, TlvObjectCodec_1.ObjectT)({
                endpointId: (0, TlvObjectCodec_1.Field)(0, TlvObjectCodec_1.UnsignedIntT),
                clusterId: (0, TlvObjectCodec_1.Field)(1, TlvObjectCodec_1.UnsignedIntT),
                id: (0, TlvObjectCodec_1.Field)(2, TlvObjectCodec_1.UnsignedIntT),
            }, TlvCodec_1.TlvType.List)),
            result: (0, TlvObjectCodec_1.Field)(1, (0, TlvObjectCodec_1.ObjectT)({
                code: (0, TlvObjectCodec_1.Field)(0, TlvObjectCodec_1.UnsignedIntT),
            })),
        })),
    }))),
    interactionModelRevision: (0, TlvObjectCodec_1.Field)(0xFF, TlvObjectCodec_1.UnsignedIntT),
});
