import { MatterDevice } from "../MatterDevice";
import { Fabric } from "../fabric/Fabric";
import { AttributeWithPath } from "./InteractionServer";
export declare class SubscriptionHandler {
    readonly subscriptionId: number;
    private readonly server;
    private readonly fabric;
    private readonly peerNodeId;
    private readonly attributes;
    private readonly minIntervalFloorMs;
    private readonly maxIntervalCeilingMs;
    static Builder: (server: MatterDevice, fabric: Fabric, peerNodeId: bigint, attributes: AttributeWithPath[], minIntervalFloorSeconds: number, maxIntervalCeilingSeconds: number) => (subscriptionId: number) => SubscriptionHandler;
    private lastUpdateTimeMs;
    private readonly listener;
    private updateTimer;
    constructor(subscriptionId: number, server: MatterDevice, fabric: Fabric, peerNodeId: bigint, attributes: AttributeWithPath[], minIntervalFloorMs: number, maxIntervalCeilingMs: number);
    sendUpdate(): Promise<void>;
    cancel(): void;
    private sendUpdateMessage;
}
