/// <reference types="node" />
import { Broadcaster } from "../common/Broadcaster";
import { MdnsServer } from "../../net/MdnsServer";
export declare class MdnsBroadcaster implements Broadcaster {
    private readonly mdnsServer;
    static create(multicastInterface?: string): Promise<MdnsBroadcaster>;
    constructor(mdnsServer: MdnsServer);
    setCommissionMode(deviceName: string, deviceType: number, vendorId: number, productId: number, discriminator: number): void;
    setFabric(operationalId: Buffer, nodeId: bigint): void;
    announce(): Promise<void>;
    close(): void;
}
