import { Message, Packet } from "../../codec/MessageCodec";
export declare const DEFAULT_IDLE_RETRANSMISSION_TIMEOUT_MS = 5000;
export declare const DEFAULT_ACTIVE_RETRANSMISSION_TIMEOUT_MS = 300;
export declare const DEFAULT_RETRANSMISSION_RETRIES = 2;
interface MrpParameters {
    idleRetransmissionTimeoutMs: number;
    activeRetransmissionTimeoutMs: number;
    retransmissionRetries: number;
}
export interface Session<T> {
    isSecure(): boolean;
    getName(): string;
    decode(packet: Packet): Message;
    encode(message: Message): Packet;
    getMrpParameters(): MrpParameters;
    getContext(): T;
    getId(): number;
    getPeerSessionId(): number;
    getNodeId(): bigint | undefined;
    getPeerNodeId(): bigint | undefined;
}
export {};
