/// <reference types="node" />
import { Packet, Message } from "../../codec/MessageCodec";
import { Fabric } from "../fabric/Fabric";
import { Session } from "./Session";
export declare class UnsecureSession<T> implements Session<T> {
    private readonly context;
    constructor(context: T);
    isSecure(): boolean;
    decode(packet: Packet): Message;
    encode(message: Message): Packet;
    getAttestationChallengeKey(): Buffer;
    setFabric(fabric: Fabric): void;
    getName(): string;
    getMrpParameters(): {
        idleRetransmissionTimeoutMs: number;
        activeRetransmissionTimeoutMs: number;
        retransmissionRetries: number;
    };
    getContext(): T;
    getId(): number;
    getPeerSessionId(): number;
    getNodeId(): undefined;
    getPeerNodeId(): undefined;
}
