/// <reference types="node" />
export declare const KDFSR1_KEY_INFO: Buffer;
export declare const KDFSR2_KEY_INFO: Buffer;
export declare const RESUME1_MIC_NONCE: Buffer;
export declare const RESUME2_MIC_NONCE: Buffer;
export declare const KDFSR2_INFO: Buffer;
export declare const KDFSR3_INFO: Buffer;
export declare const TBE_DATA2_NONCE: Buffer;
export declare const TBE_DATA3_NONCE: Buffer;
export declare const CaseSigma1T: import("../../../codec/TlvObjectCodec").Template<import("../../../util/Type").Merge<{
    sessionId: number;
    random: Buffer;
    destinationId: Buffer;
    ecdhPublicKey: Buffer;
}, {
    mrpParams?: import("../../../util/Type").Merge<{}, {
        idleRetransTimeoutMs?: number | undefined;
        activeRetransTimeoutMs?: number | undefined;
    }, {} & {
        idleRetransTimeoutMs?: number | undefined;
        activeRetransTimeoutMs?: number | undefined;
    }> | undefined;
    resumptionId?: Buffer | undefined;
    resumeMic?: Buffer | undefined;
}, {
    sessionId: number;
    random: Buffer;
    destinationId: Buffer;
    ecdhPublicKey: Buffer;
} & {
    mrpParams?: import("../../../util/Type").Merge<{}, {
        idleRetransTimeoutMs?: number | undefined;
        activeRetransTimeoutMs?: number | undefined;
    }, {} & {
        idleRetransTimeoutMs?: number | undefined;
        activeRetransTimeoutMs?: number | undefined;
    }> | undefined;
    resumptionId?: Buffer | undefined;
    resumeMic?: Buffer | undefined;
}>>;
export declare const CaseSigma2T: import("../../../codec/TlvObjectCodec").Template<import("../../../util/Type").Merge<{
    encrypted: Buffer;
    sessionId: number;
    random: Buffer;
    ecdhPublicKey: Buffer;
}, {
    mrpParams?: import("../../../util/Type").Merge<{}, {
        idleRetransTimeoutMs?: number | undefined;
        activeRetransTimeoutMs?: number | undefined;
    }, {} & {
        idleRetransTimeoutMs?: number | undefined;
        activeRetransTimeoutMs?: number | undefined;
    }> | undefined;
}, {
    encrypted: Buffer;
    sessionId: number;
    random: Buffer;
    ecdhPublicKey: Buffer;
} & {
    mrpParams?: import("../../../util/Type").Merge<{}, {
        idleRetransTimeoutMs?: number | undefined;
        activeRetransTimeoutMs?: number | undefined;
    }, {} & {
        idleRetransTimeoutMs?: number | undefined;
        activeRetransTimeoutMs?: number | undefined;
    }> | undefined;
}>>;
export declare const CaseSigma2ResumeT: import("../../../codec/TlvObjectCodec").Template<import("../../../util/Type").Merge<{
    sessionId: number;
    resumptionId: Buffer;
    resumeMic: Buffer;
}, {}, {
    sessionId: number;
    resumptionId: Buffer;
    resumeMic: Buffer;
} & {}>>;
export declare const CaseSigma3T: import("../../../codec/TlvObjectCodec").Template<import("../../../util/Type").Merge<{
    encrypted: Buffer;
}, {}, {
    encrypted: Buffer;
} & {}>>;
export declare const SignedDataT: import("../../../codec/TlvObjectCodec").Template<import("../../../util/Type").Merge<{
    ecdhPublicKey: Buffer;
    newOpCert: Buffer;
    peerEcdhPublicKey: Buffer;
}, {
    intermediateCACert?: Buffer | undefined;
}, {
    ecdhPublicKey: Buffer;
    newOpCert: Buffer;
    peerEcdhPublicKey: Buffer;
} & {
    intermediateCACert?: Buffer | undefined;
}>>;
export declare const EncryptedDataSigma2T: import("../../../codec/TlvObjectCodec").Template<import("../../../util/Type").Merge<{
    signature: Buffer;
    resumptionId: Buffer;
    newOpCert: Buffer;
}, {
    intermediateCACert?: Buffer | undefined;
}, {
    signature: Buffer;
    resumptionId: Buffer;
    newOpCert: Buffer;
} & {
    intermediateCACert?: Buffer | undefined;
}>>;
export declare const EncryptedDataSigma3T: import("../../../codec/TlvObjectCodec").Template<import("../../../util/Type").Merge<{
    signature: Buffer;
    newOpCert: Buffer;
}, {
    intermediateCACert?: Buffer | undefined;
}, {
    signature: Buffer;
    newOpCert: Buffer;
} & {
    intermediateCACert?: Buffer | undefined;
}>>;
