"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.EncryptedDataSigma3T = exports.EncryptedDataSigma2T = exports.SignedDataT = exports.CaseSigma3T = exports.CaseSigma2ResumeT = exports.CaseSigma2T = exports.CaseSigma1T = exports.TBE_DATA3_NONCE = exports.TBE_DATA2_NONCE = exports.KDFSR3_INFO = exports.KDFSR2_INFO = exports.RESUME2_MIC_NONCE = exports.RESUME1_MIC_NONCE = exports.KDFSR2_KEY_INFO = exports.KDFSR1_KEY_INFO = void 0;
const TlvObjectCodec_1 = require("../../../codec/TlvObjectCodec");
exports.KDFSR1_KEY_INFO = Buffer.from("Sigma1_Resume");
exports.KDFSR2_KEY_INFO = Buffer.from("Sigma2_Resume");
exports.RESUME1_MIC_NONCE = Buffer.from("NCASE_SigmaS1");
exports.RESUME2_MIC_NONCE = Buffer.from("NCASE_SigmaS2");
exports.KDFSR2_INFO = Buffer.from("Sigma2");
exports.KDFSR3_INFO = Buffer.from("Sigma3");
exports.TBE_DATA2_NONCE = Buffer.from("NCASE_Sigma2N");
exports.TBE_DATA3_NONCE = Buffer.from("NCASE_Sigma3N");
exports.CaseSigma1T = (0, TlvObjectCodec_1.ObjectT)({
    random: (0, TlvObjectCodec_1.Field)(1, TlvObjectCodec_1.ByteStringT),
    sessionId: (0, TlvObjectCodec_1.Field)(2, TlvObjectCodec_1.UnsignedIntT),
    destinationId: (0, TlvObjectCodec_1.Field)(3, TlvObjectCodec_1.ByteStringT),
    ecdhPublicKey: (0, TlvObjectCodec_1.Field)(4, TlvObjectCodec_1.ByteStringT),
    mrpParams: (0, TlvObjectCodec_1.OptionalField)(5, (0, TlvObjectCodec_1.ObjectT)({
        idleRetransTimeoutMs: (0, TlvObjectCodec_1.OptionalField)(1, TlvObjectCodec_1.UnsignedIntT),
        activeRetransTimeoutMs: (0, TlvObjectCodec_1.OptionalField)(2, TlvObjectCodec_1.UnsignedIntT),
    })),
    resumptionId: (0, TlvObjectCodec_1.OptionalField)(6, TlvObjectCodec_1.ByteStringT),
    resumeMic: (0, TlvObjectCodec_1.OptionalField)(7, TlvObjectCodec_1.ByteStringT),
});
exports.CaseSigma2T = (0, TlvObjectCodec_1.ObjectT)({
    random: (0, TlvObjectCodec_1.Field)(1, TlvObjectCodec_1.ByteStringT),
    sessionId: (0, TlvObjectCodec_1.Field)(2, TlvObjectCodec_1.UnsignedIntT),
    ecdhPublicKey: (0, TlvObjectCodec_1.Field)(3, TlvObjectCodec_1.ByteStringT),
    encrypted: (0, TlvObjectCodec_1.Field)(4, TlvObjectCodec_1.ByteStringT),
    mrpParams: (0, TlvObjectCodec_1.OptionalField)(5, (0, TlvObjectCodec_1.ObjectT)({
        idleRetransTimeoutMs: (0, TlvObjectCodec_1.OptionalField)(1, TlvObjectCodec_1.UnsignedIntT),
        activeRetransTimeoutMs: (0, TlvObjectCodec_1.OptionalField)(2, TlvObjectCodec_1.UnsignedIntT),
    })),
});
exports.CaseSigma2ResumeT = (0, TlvObjectCodec_1.ObjectT)({
    resumptionId: (0, TlvObjectCodec_1.Field)(1, TlvObjectCodec_1.ByteStringT),
    resumeMic: (0, TlvObjectCodec_1.Field)(2, TlvObjectCodec_1.ByteStringT),
    sessionId: (0, TlvObjectCodec_1.Field)(3, TlvObjectCodec_1.UnsignedIntT),
});
exports.CaseSigma3T = (0, TlvObjectCodec_1.ObjectT)({
    encrypted: (0, TlvObjectCodec_1.Field)(1, TlvObjectCodec_1.ByteStringT),
});
exports.SignedDataT = (0, TlvObjectCodec_1.ObjectT)({
    newOpCert: (0, TlvObjectCodec_1.Field)(1, TlvObjectCodec_1.ByteStringT),
    intermediateCACert: (0, TlvObjectCodec_1.OptionalField)(2, TlvObjectCodec_1.ByteStringT),
    ecdhPublicKey: (0, TlvObjectCodec_1.Field)(3, TlvObjectCodec_1.ByteStringT),
    peerEcdhPublicKey: (0, TlvObjectCodec_1.Field)(4, TlvObjectCodec_1.ByteStringT),
});
exports.EncryptedDataSigma2T = (0, TlvObjectCodec_1.ObjectT)({
    newOpCert: (0, TlvObjectCodec_1.Field)(1, TlvObjectCodec_1.ByteStringT),
    intermediateCACert: (0, TlvObjectCodec_1.OptionalField)(2, TlvObjectCodec_1.ByteStringT),
    signature: (0, TlvObjectCodec_1.Field)(3, TlvObjectCodec_1.ByteStringT),
    resumptionId: (0, TlvObjectCodec_1.Field)(4, TlvObjectCodec_1.ByteStringT),
});
exports.EncryptedDataSigma3T = (0, TlvObjectCodec_1.ObjectT)({
    newOpCert: (0, TlvObjectCodec_1.Field)(1, TlvObjectCodec_1.ByteStringT),
    intermediateCACert: (0, TlvObjectCodec_1.OptionalField)(2, TlvObjectCodec_1.ByteStringT),
    signature: (0, TlvObjectCodec_1.Field)(3, TlvObjectCodec_1.ByteStringT),
});
