/// <reference types="node" />
import { Template } from "../../../codec/TlvObjectCodec";
import { MessageExchange } from "../../common/MessageExchange";
export declare class SecureChannelMessenger<ContextT> {
    protected readonly exchange: MessageExchange<ContextT>;
    constructor(exchange: MessageExchange<ContextT>);
    nextMessage(expectedMessageType?: number): Promise<import("../../../codec/MessageCodec").Message>;
    nextMessageDecoded<T>(expectedMessageType: number, template: Template<T>): Promise<T>;
    waitForSuccess(): Promise<void>;
    send<T>(message: T, type: number, template: Template<T>): Promise<Buffer>;
    sendError(): Promise<void>;
    sendSuccess(): Promise<void>;
    getChannelName(): string;
    close(): void;
    private sendStatusReport;
    protected throwIfError(messageType: number, payload: Buffer): void;
}
