"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.SecureChannelProtocol = void 0;
const SecureChannelMessages_1 = require("./SecureChannelMessages");
class SecureChannelProtocol {
    constructor(paseCommissioner, caseCommissioner) {
        this.paseCommissioner = paseCommissioner;
        this.caseCommissioner = caseCommissioner;
    }
    getId() {
        return SecureChannelMessages_1.SECURE_CHANNEL_PROTOCOL_ID;
    }
    onNewExchange(exchange, message) {
        const messageType = message.payloadHeader.messageType;
        switch (messageType) {
            case 32:
                this.paseCommissioner.onNewExchange(exchange);
                break;
            case 48:
                this.caseCommissioner.onNewExchange(exchange);
                break;
            default:
                throw new Error(`Unexpected initial message on secure channel protocol: ${messageType.toString(16)}`);
        }
    }
}
exports.SecureChannelProtocol = SecureChannelProtocol;
