import { Record } from "../codec/DnsCodec";
import { UdpMulticastServer } from "./UdpMulticastServer";
export declare const MDNS_BROADCAST_IP = "224.0.0.251";
export declare const MDNS_BROADCAST_PORT = 5353;
export declare class MdnsServer {
    private readonly multicastInterface;
    private readonly multicastServer;
    static create(multicastInterface?: string): Promise<MdnsServer>;
    private readonly network;
    private recordsGenerator;
    private readonly records;
    constructor(multicastInterface: string | undefined, multicastServer: UdpMulticastServer);
    private handleDnsMessage;
    announce(): Promise<void>;
    setRecordsGenerator(generator: (ip: string, mac: string) => Record<any>[]): void;
    close(): void;
    private getIpMacsForAnnounce;
    private queryRecords;
}
