/// <reference types="node" />
import { UdpChannel } from './UdpChannel';
import { Channel } from "./Channel";
import { NetInterface, NetListener } from "./NetInterface";
export declare class UdpInterface implements NetInterface {
    private readonly server;
    static create(port: number, address?: string): Promise<UdpInterface>;
    constructor(server: UdpChannel);
    openChannel(address: string, port: number): Promise<UdpConnection>;
    onData(listener: (channel: Channel<Buffer>, messageBytes: Buffer) => void): NetListener;
}
declare class UdpConnection implements Channel<Buffer> {
    private readonly server;
    private readonly peerAddress;
    private readonly peerPort;
    constructor(server: UdpChannel, peerAddress: string, peerPort: number);
    send(data: Buffer): Promise<void>;
    getName(): string;
}
export {};
