/// <reference types="node" />
import { UdpChannel, UdpChannelOptions } from "./UdpChannel";
export interface UdpMulticastServerOptions extends UdpChannelOptions {
    broadcastAddress: string;
    restrictToInterfaceIp?: string;
}
export declare class UdpMulticastServer {
    private readonly network;
    private readonly broadcastAddress;
    private readonly broadcastPort;
    private readonly server;
    private readonly restrictToInterfaceIp?;
    static create({ restrictToInterfaceIp, broadcastAddress, listeningPort }: UdpMulticastServerOptions): Promise<UdpMulticastServer>;
    private readonly broadcastChannels;
    private constructor();
    onMessage(listener: (message: Buffer, peerAddress: string) => void): void;
    send(message: Buffer, interfaceIp?: string): Promise<void>;
    createBroadcastChannel(interfaceIp: string): Promise<UdpChannel>;
    close(): void;
}
