"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.NetworkFake = void 0;
const Network_1 = require("../Network");
const UdpChannelFake_1 = require("./UdpChannelFake");
class NetworkFake extends Network_1.Network {
    constructor(ipMacs) {
        super();
        this.ipMacs = ipMacs;
    }
    createUdpChannel(options) {
        return UdpChannelFake_1.UdpChannelFake.create(options);
    }
    getIpMacAddresses() {
        return this.ipMacs;
    }
    getIpMacOnInterface(remoteAddress) {
        const remoteAddressPrefix = remoteAddress.slice(0, 6);
        return this.ipMacs.find(({ ip, mac }) => ip.slice(0, 6) === remoteAddressPrefix);
    }
}
exports.NetworkFake = NetworkFake;
