/// <reference types="node" />
import { UdpChannel, UdpChannelOptions } from "../UdpChannel";
import { NetListener } from "../NetInterface";
import { SimulatedNetwork } from "./SimulatedNetwork";
export declare class UdpChannelFake implements UdpChannel {
    private readonly network;
    private readonly address;
    private readonly port;
    private readonly multicastInterface?;
    static create({ listeningAddress: address, listeningPort: port, multicastInterface }: UdpChannelOptions): Promise<UdpChannelFake>;
    private readonly netListeners;
    constructor(network: SimulatedNetwork, address: string, port: number, multicastInterface?: string | undefined);
    onData(listener: (peerAddress: string, peerPort: number, data: Buffer) => void): NetListener;
    send(address: string, port: number, data: Buffer): Promise<void>;
    close(): void;
}
