"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.LEBufferWriter = void 0;
class LEBufferWriter {
    constructor() {
        this.chunks = new Array();
    }
    writeInt8(value) {
        const buffer = Buffer.alloc(1);
        buffer.writeInt8(value);
        this.chunks.push(buffer);
    }
    writeInt16(value) {
        const buffer = Buffer.alloc(2);
        buffer.writeInt16LE(value);
        this.chunks.push(buffer);
    }
    writeInt32(value) {
        const buffer = Buffer.alloc(4);
        buffer.writeInt32LE(value);
        this.chunks.push(buffer);
    }
    writeInt64(value) {
        const buffer = Buffer.alloc(8);
        buffer.writeBigInt64LE(value);
        this.chunks.push(buffer);
    }
    writeUInt8(value) {
        const buffer = Buffer.alloc(1);
        buffer.writeUInt8(value);
        this.chunks.push(buffer);
    }
    writeUInt16(value) {
        const buffer = Buffer.alloc(2);
        buffer.writeUInt16LE(value);
        this.chunks.push(buffer);
    }
    writeUInt32(value) {
        const buffer = Buffer.alloc(4);
        buffer.writeUInt32LE(value);
        this.chunks.push(buffer);
    }
    writeUInt64(value) {
        const buffer = Buffer.alloc(8);
        buffer.writeBigUInt64LE(value);
        this.chunks.push(buffer);
    }
    writeFloat(value) {
        const buffer = Buffer.alloc(4);
        buffer.writeFloatLE(value);
        this.chunks.push(buffer);
    }
    writeDouble(value) {
        const buffer = Buffer.alloc(8);
        buffer.writeDoubleLE(value);
        this.chunks.push(buffer);
    }
    writeString(value) {
        this.chunks.push(Buffer.from(value));
    }
    writeBytes(value) {
        this.chunks.push(value);
    }
    toBuffer() {
        return Buffer.concat(this.chunks);
    }
}
exports.LEBufferWriter = LEBufferWriter;
